defmodule Manganese.RenderKit.MixProject do
  use Mix.Project

  def project do
    [
      app: :manganese_render_kit,
      version: "0.2.3",
      elixir: "~> 1.7",
      start_permanent: Mix.env() == :prod,
      deps: deps(),
      package: package()
    ]
  end

  # Run "mix help compile.app" to learn about applications.
  def application do
    [
      extra_applications: [ :logger ]
    ]
  end

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      # ExDoc
      { :ex_doc, "~> 0.19", only: :dev, runtime: false },

      # Ecto
      { :ecto, "~> 3.0" },

      # Manganese CoreKit
      { :manganese_core_kit, "~> 0.1" },

      # Manganese SerializationKit
      { :manganese_serialization_kit, "~> 0.2" }
    ]
  end

  defp package do
    [
      name: "manganese_render_kit",
      description: "Library for using Unity renders from RenderKit in Elixir",
      licenses: [ "Apache 2.0" ],
      links: %{
        "GitLab" => "https://gitlab.com/manganese/render-kit/render-kit-uploader-elixir"
      },
      maintainers: [
        "Samuel Goodell"
      ]
    ]
  end
end
